<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPanelSettingInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfPanelSettingInfo extends AbstractStructArrayBase
{
    /**
     * The PanelSettingInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\PanelSettingInfo[]
     */
    public $PanelSettingInfo;
    /**
     * Constructor method for ArrayOfPanelSettingInfo
     * @uses ArrayOfPanelSettingInfo::setPanelSettingInfo()
     * @param \CustomerManagement\StructType\PanelSettingInfo[] $panelSettingInfo
     */
    public function __construct(array $panelSettingInfo = array())
    {
        $this
            ->setPanelSettingInfo($panelSettingInfo);
    }
    /**
     * Get PanelSettingInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\PanelSettingInfo[]|null
     */
    public function getPanelSettingInfo()
    {
        return isset($this->PanelSettingInfo) ? $this->PanelSettingInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPanelSettingInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPanelSettingInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePanelSettingInfoForArrayConstraintsFromSetPanelSettingInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPanelSettingInfoPanelSettingInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfPanelSettingInfoPanelSettingInfoItem instanceof \CustomerManagement\StructType\PanelSettingInfo) {
                $invalidValues[] = is_object($arrayOfPanelSettingInfoPanelSettingInfoItem) ? get_class($arrayOfPanelSettingInfoPanelSettingInfoItem) : sprintf('%s(%s)', gettype($arrayOfPanelSettingInfoPanelSettingInfoItem), var_export($arrayOfPanelSettingInfoPanelSettingInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PanelSettingInfo property can only contain items of type \CustomerManagement\StructType\PanelSettingInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PanelSettingInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PanelSettingInfo[] $panelSettingInfo
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingInfo
     */
    public function setPanelSettingInfo(array $panelSettingInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($panelSettingInfoArrayErrorMessage = self::validatePanelSettingInfoForArrayConstraintsFromSetPanelSettingInfo($panelSettingInfo))) {
            throw new \InvalidArgumentException($panelSettingInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($panelSettingInfo) || (is_array($panelSettingInfo) && empty($panelSettingInfo))) {
            unset($this->PanelSettingInfo);
        } else {
            $this->PanelSettingInfo = $panelSettingInfo;
        }
        return $this;
    }
    /**
     * Add item to PanelSettingInfo value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\PanelSettingInfo $item
     * @return \CustomerManagement\ArrayType\ArrayOfPanelSettingInfo
     */
    public function addToPanelSettingInfo(\CustomerManagement\StructType\PanelSettingInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\PanelSettingInfo) {
            throw new \InvalidArgumentException(sprintf('The PanelSettingInfo property can only contain items of type \CustomerManagement\StructType\PanelSettingInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PanelSettingInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\PanelSettingInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\PanelSettingInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\PanelSettingInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\PanelSettingInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\PanelSettingInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PanelSettingInfo
     */
    public function getAttributeName()
    {
        return 'PanelSettingInfo';
    }
}
